{ Behaviors in priority order:
  Escape        avoids white line
  Attack        drives if detected by IR sensors
  Pursue        drives if detected by sonar
  Drive         drives if nothing detected
  ir range on 6L&7R edge sensors on 1L * 0R}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 6_000_000
  NUM_BEHAVIORS = 4
  SPEED_BASE = 2 *  NUM_BEHAVIORS
  TURN_RATE_BASE = 3 * NUM_BEHAVIORS
  ESCAPE_PRIORITY = 0
  ATTACK_PRIORITY = 1
  PURSUE_PRIORITY = 2
  DRIVE_PRIORITY = 3
  MAX_FWD = 100 ' IS THIS TRUE??
  MAX_BCK = -100 ' IS THIS TRUE??
  #0, LEFT, RIGHT, WALL, SONAR
  #2, CENTER
  WHEEL_SPACING = 40
VAR
  long escapeStack[400], attackStack[40], pursueStack[40], driveStack[40], telemetryStack[40]
  long wantControl[NUM_BEHAVIORS], speed[NUM_BEHAVIORS], turnRate[NUM_BEHAVIORS]
  long CYCLE_TIME, wait, startWait
  long leftmotor, rightmotor
OBJ 
    Sumo : "SumoInit"
    SumoBot : "SumoBot"
    Escape : "Escape"
    sio : "FullDuplexSerial"
Pub Main  | i
  startWait := cnt
  CYCLE_TIME := 480000000 'clkfreq * 5 '/ 50
  Init
  wait := cnt
  sio.str(string("Begin",13))
  sio.dec(wait)
  sio.tx(13)
  repeat
    sio.dec(CYCLE_TIME)
    sio.tx(13)
    sio.dec(clkfreq)
    sio.tx(13)
    wait +=  CYCLE_TIME
    sio.dec(wait)
    sio.tx(13)
    repeat i from 0 to NUM_BEHAVIORS
                                                        ' nul repeat loop
    waitcnt (wait)
Pub Esc(dataAddr)
  Escape.Main(dataAddr)
PRI Init       | cog
  sumo.Init
  SumoBot.Init
  sio.Start(31,30, 0, 115200)
  cognew(Esc(@wantControl), @escapeStack)     ' need to check if free
           
      
